<template>
  <div class="shadow-lg flex flex-wrap w-full lg:w-2/3 mx-auto mb-5">
    <div
        class="bg-cover bg-bottom border w-full md:w-1/3 md:h-auto relative bg-yellow-500 flex justify-center"
    >
      <font-awesome-icon
          :icon="this.roadTrip.type === 'cityTour' ? 'map-pin' : 'route'"
          class="p-5 my-10 rounded-lg"
          size="10x"
      />
    </div>

    <div class="bg-blue-600 w-full md:w-2/3">
      <div class="h-full mx-auto px-6 md:px-0 md:pt-6 md:-ml-6 relative">
        <div
            class="bg-white lg:h-full p-6 -mt-6 md:mt-0 relative mb-4 md:mb-0 flex flex-wrap md:flex-wrap items-center"
        >
          <div
              class="w-full lg:w-1/5 lg:border-right lg:border-solid text-center md:text-left"
          >
            <h3 v-if="author">{{ author.firstname }} {{ author.lastname }}</h3>
            <h3 v-if="roadtripsGestion.isAdminMode && !author">Auteur inconnu</h3>
            <p class="mb-0 mt-3 text-grey-dark text-sm italic">
              Crée :<br/>
              {{ this.formattedDate }}
            </p>
            <hr class="w-1/4 md:ml-0 mt-4 border lg:hidden"/>
          </div>
          <div class="w-full lg:w-3/5 lg:px-3">
            <h2 class="text-center p-2 mb-5 font-bold">
              {{ this.roadTrip.name }}
            </h2>
            <div class="text-md text-justify md:text-left text-sm">
              <p>{{ this.textByType[this.roadTrip.type] }}</p>
              <p v-if="this.roadTrip.type === 'cityTour'">
                {{this.roadTrip.nameCommune}}
              </p>
              <p v-if="this.roadTrip.type === 'AToB' && this.roadTrip.nameCommuneA" >
                Départ {{this.roadTrip.nameCommuneA}}
              </p>
              <p v-if="this.roadTrip.type === 'AToB' && this.roadTrip.nameCommuneB" >
                Arrivée {{this.roadTrip.nameCommuneB}}
              </p>
              <p>
                {{ roadTrip.nbDays }} jour{{
                  this.roadTrip.nbDays > 1 ? "s" : ""
                }}
              </p>
              <p>
                {{
                  nbPOIs
                }}
                étape{{
                  nbPOIs > 1
                      ? "s"
                      : ""
                }}
              </p>
              <p>
                {{
                  nbRestaurants
                }}
                restaurant{{
                  nbRestaurants > 1
                      ? "s"
                      : ""
                }}
              </p>
              <p>
                {{ nbHostels }}
                hôtel{{
                  (
                      this.roadTrip.type === "AToB" &&
                      nbHostels > 1
                  ) ? 's' : ''
                }}
              </p>
            </div>
          </div>
          <div
              class="w-full lg:w-1/5 mt-6 lg:mt-0 lg:px-4 text-center md:text-left"
          >
            <button
                class="bg-green-500 hover:bg-green-700 text-white border border-solid w-1/3 lg:w-full py-2 rounded-lg"
                @click="roadtripsGestion.showRoadTrip(id)"
            >
              Voir
            </button>
            <button
                class="bg-red-500 hover:bg-red-700 text-white border border-solid w-1/3 lg:w-full py-2 rounded-lg"
                @click="roadtripsGestion.deleteRoadTrip(id)"
            >
              Supprimer
            </button>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
export default {
  name: "ListRoadtrip",
  inject: ["roadtripsGestion"],
  data: () => ({
    textByType: {
      AToB: "Road trip",
      cityTour: "City tour",
    },
  }),
  computed: {
    nbHostels() {
      return this.roadTrip.road.filter(({POIType}) => POIType === "hostel").length
    },
    nbRestaurants() {
      return this.roadTrip.road.filter(({POIType}) => POIType === "restaurant").length
    },
    nbPOIs() {
      return this.roadTrip.road.filter(({POIType}) => POIType === "POI").length
    },
    formattedDate() {
      return (
          this.addMissingZeros(this.date.getDate()) +
          "/" +
          this.addMissingZeros(this.date.getMonth() + 1) +
          "/" +
          this.date.getFullYear() +
          " " +
          this.addMissingZeros(this.date.getHours()) +
          ":" +
          this.addMissingZeros(this.date.getMinutes())
      );
    },
  },
  methods: {
    addMissingZeros(s, n = 2) {
      if (typeof s === "number") s = s.toString();

      while (s.length < n) s = "0" + s;
      return s;
    },
  },
  props: {
    roadTrip: Object,
    id: String,
    date: Date,
    author: {
      type: Object,
      default: null,
    },
  },
};
</script>

<style scoped></style>
